capt program drop _all
mata: mata clear

type flipmat.ado


/*
program flipmat
	version 10.1
	syntax name, [HORIZ]
	confirm matrix `namelist'
	mata: mf_flipmat("`namelist'", "`horiz'")
end
*/

do mf_flipmat.mata

type mf_flipmat.mata

/*
version 10.1
mata:
void function mf_flipmat(string scalar name, string scalar horiz)
{
	X = st_matrix(name)
	rs = st_matrixrowstripe(name)
	cs = st_matrixcolstripe(name)
	if (horiz == "") {
	        X = (rows(X)>1 ? X[rows(X)..1, .]: X)
	        rs = (rows(rs)>1 ? rs[rows(rs)..1, .]: rs)
	}
	else {
	        X = (cols(X)>1 ? X[., cols(X)..1]: X)
	        cs = (rows(cs)>1 ? cs[rows(cs)..1, .]: cs)
	}
	st_matrix(name, X)
	st_matrixcolstripe(name, cs)
	st_matrixrowstripe(name, rs)
}
end
*/

clear
set obs 25
set seed 20071110
g id = int(1000*uniform())
g hw = int(50*uniform()+5)
g mt = int(2*hw + 5*invnorm(uniform()))
g final = int(4*hw + 7*invnorm(uniform()))
g total = hw + mt + final
sort total
su
mkmat hw mt final total, mat(grades)
mkmat id, mat(id)
forv i=1/25 {
	local id = string(id[`i',1])
	local idnr "`idnr' `id'"
}
mat rownames grades = `idnr'


use course, clear
mat list grades, noheader

flipmat grades
mat list grades, noheader

flipmat grades, horiz
mat list grades, noheader

